unit CarStop7;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TFCarStop7 = class(TForm)
    pgain: TTrackBar;
    Vgain: TTrackBar;
    Cmass: TTrackBar;
    SetPos: TTrackBar;
    AGain: TTrackBar;
    SetAcLimGain: TTrackBar;
    SetAccelRef: TTrackBar;
    Button1: TButton;
    InitSpeed: TTrackBar;
    procedure StartCar(Sender: TObject);
    procedure pgainChange(Sender: TObject);
    procedure VgainChange(Sender: TObject);
    procedure CmassChange(Sender: TObject);
    procedure SetPosChange(Sender: TObject);
    procedure AGainChange(Sender: TObject);
    procedure SetAcLimGainChange(Sender: TObject);
    procedure SetAccelRefChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure InitSpeedChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   procedure idleloop(Sender: TObject; var Done: boolean);
  end;

var
  FCarStop7: TFCarStop7;

implementation

{$R *.dfm}
{$R-}

var carpos, carvel, caraccel,
    accelgain, accelref,accelerror,
    AccelLimRef,AccelLimGain,maxaccelerror,
    brakepush, brakeforce, Kfrict, engineforce,
    posref,poserror,posgain,Xscale,
    velref,velpercep,velerror,velgain,velfb, initvel,
    idlespeed, carmass,dt: double;
    x,y,lasta,skip, carlen, carwid: smallint;
    t,oldt,p,oldp,v,oldv,b,oldb,a, olda,yzero, braketime: smallint;
    Pos: trect;
    freq: int64;
    firsttime, realtime, firstdecel, brakestart, brakeend: boolean;

procedure initprogram;
begin
  Xscale := 4;
  Kfrict := 150.0;   // Newton/Kg-MPS
  AccelLimRef := -5.0;
  AccelLimGain := 50.0;
  velpercep := 0.0;
  brakepush := 0.0;
  InitVel := FCarStop7.InitSpeed.position;   // Km/Hr
  carvel := initvel*1000.0/3600.0; // meters per sec
  carpos := 0;
  carlen := round(5*Xscale);
  carwid := round(2.2*XScale);
  brakepush := 0.0;
  idlespeed := 10; //KPH
  posref := FCarStop7.setpos.position;
  velfb := 0;
  yzero := FCarStop7.clientheight - 140;
  firstdecel := false;
  brakestart := false;
  brakeend := false;
  t := 0;
  lasta := 0;
  dt := 0.003;
 with FCarStop7.canvas do
 begin
   skip := round(60.0/(FCarStop7.clientwidth*dt));
   CopyMode := cmSrcCopy;
   brush.color := RGB(220,220,220);
   fillrect(rect(0,0,FCarStop7.clientwidth - 1,FCarStop7.clientheight - 1));
   with FCarStop7,FCarStop7.canvas do
   begin
    pen.color := clRed;
    pen.width := 2;
    moveto(round(Xscale*posref + 21),
      clientheight div 2 - 40);
    lineto(round(XScale*posref+ 21),
      clientheight div 2 - 70);
    moveto(0,yzero);
    lineto(clientwidth-1,yzero);
    moveto(0,yzero - round(posref));
    lineto(clientwidth-1,yzero - round(posref));
    font.color := clBlack;
    PosGain := (pgain.position)/pgain.max;
    textout(pgain.left,pgain.top+20,'Pos Gain = '+floattostrf(posgain,fffixed,5,2));
    VelGain := 10.0*vgain.position/vgain.max;
    textout(vgain.left,vgain.top+20,'Vel Gain = '+floattostrf(velgain,fffixed,5,2));
    AccelGain := 10.0*again.position/again.max;
    textout(again.left,again.top+20,
     'Accel Gain = '+floattostrf(accelgain,fffixed,5,2));
    carmass := cmass.position;
    textout(cmass.left,cmass.top+20,
     'Car Mass = '+floattostrf(carmass,fffixed,5,2) + ' Kg');
    textout(SetPos.left,SetPos.top+20,
     'Ref Pos = '+floattostrf(PosRef,fffixed,5,2));
    InitVel := InitSpeed.position;
    FCarStop7.Canvas.textout(InitSpeed.left,InitSpeed.top+20,
     'Initial Vel = '+floattostrf(InitVel,fffixed,5,2) + ' Km/Hr');
    AccelLimGain := 100*SetAcLimGain.position/SetAcLimGain.max;
    textout(SetAcLimGain.left,SetAcLimGain.top+20,
     'Accel Limit Gain = '+floattostrf(AccelLimGain,fffixed,5,2));
    AccelLimRef := -SetAccelRef.position/10.0;
    textout(SetAccelRef.left,SetAccelRef.top+20,
     'Accel Limit Ref = '+floattostrf(AccelLimRef,fffixed,5,2));
    Font.color := clRed;
    textout(80,yzero - 20,'VELOCITY');
    textout(200,yzero - round(posref) - 20,
     'POSITION REF = ' + floattostrf(posref,fffixed,5,1) + ' METERS');
   end;
    Font.color := clBlack;
    textout(30,yzero+15,'SECONDS');
    textout(FCarstop7.InitSpeed.left,FCarStop7.InitSpeed.top+40,'Idle speed = ' +
      floattostrf(idlespeed,fffixed,5,2) + ' Km/Hr');
 end;
end;


procedure showcar;
var u: integer;
begin
 with FCarStop7,canvas do
 begin
  if t = 0 then
  begin
   oldt := 0;
   oldp := 0;
   oldv := 0;
   olda := 0;
  end;
  if t mod 10 = 0 then
  begin
  font.color := clBlack;
  brush.color := RGB(220,220,220);
  pos := rect(round(Xscale*(posref) - 40),clientheight div 2 - 30,
               round(Xscale*(posref) + 80),clientheight div 2 - 30 + 15);
  fillrect(pos);
  textout(round(Xscale*posref),clientheight div 2 - 30,'    '+ floattostrf(carpos,fffixed,8,2) + '    ');
  y := Clientheight div 2 - 50;
  pos := rect(x,y,x+carlen,y-carwid);
  fillrect(pos);
  brush.color := clBlack;      // draw new car rectangle
  x := round(Xscale*carpos);
  pos := rect(x,y,x+carlen,y-carwid);
  fillrect(pos);
  brush.color := clWhite;
  moveto(oldt div skip,oldp);     // plot position
  p := yzero - round(carpos);
  pen.color := clGreen;
  lineto(t div skip,p);
  oldp := p;
  moveto(oldt div skip,oldv);     // plot  velocity
  v := yzero - round(3*velpercep);
  pen.color := clRed;
  if t > 0 then
  lineto(t div skip,v);
  oldv := v;
  moveto(oldt div skip,oldb);     // plot brake pedal force
  b := yzero - round(50.0*brakepush);
  pen.color := RGB(0,200, 255);
  lineto(t div skip,b);
  oldb := b;
  if (not brakestart) and (brakepush > 0.5) then
  begin
   moveto(x + carlen, clientheight div 2 - 30);
   lineto(x + carlen, clientheight div 2 - 70);
   textout(x, clientheight div 2 - 98,
     'BRAKE START at '+ floattostrf(posref - carpos,fffixed,8,2) + ' Meters');
   brakestart := true;
   braketime := t;
  end;
  if (t > braketime + 10) and(not brakeend) and (brakestart) and (brakepush < 2) then
  begin
   moveto(x + carlen, clientheight div 2 - 30);
   lineto(x + carlen, clientheight div 2 - 70);
   textout(x, clientheight div 2 - 85,
     'CREEP START at '+ floattostrf(posref - carpos,fffixed,8,2) + ' Meters');
   brakeend := true;
  end;
  moveto(oldt div skip,olda);     // plot acceleration
  a := yzero - round(20*caraccel);
  pen.color := RGB(180,100,150);
  lineto(t div skip,a);
  if not firstdecel and (a > yzero - 30) and (a < lasta) then
  begin                         // label deceleration trace
   if t div skip < 60 then u := 0 else u := 60;
   Font.color := RGB(180,100,150);
   textout(t div skip - u,a + 5,'DECELERATION');
   firstdecel := true
  end;
  lasta := a;
  olda := a;
  oldt := t;
  end;
  if ((t mod round(10/dt)) = 0) and (t > 0) and (t < 15/dt) then
  begin
   Font.color := clGreen;        // label position trace
   brush.Color := clWhite;
   textout(230,yzero - round(carpos) + 3,'POSITION');
   Font.color := RGB(0,200, 255);
   textout(230,b+3,'PEDAL FORCE');
   font.color := clBlack;
  end;
  if (t mod round(1/dt)) = 0 then    // show minor time divisions
  begin
   pen.color := clRed;
   moveto(t div skip, yzero - 5);
   lineto(t div skip,yzero + 5);
  end;
  if (t mod round(10/dt)) = 0 then   // show major time divisions
  begin
   moveto(t div skip, yzero - 15);
   lineto(t div skip,yzero + 15);
   textout(t div skip - 10, yzero +15,floattostrf(t*dt,fffixed,5,1));
  end;
  t := t + 1;
  if t >= skip*clientwidth then        // reset plot at picture boundary
  begin
   t := 0;
   initprogram;
  end;
 end;
end;

procedure movecar;
begin
 carpos := carpos + (carvel + 0.5*caraccel*dt)*dt;
 carvel := carvel + caraccel*dt;
 velpercep := 50*carpos - velfb;
 velfb := velfb + velpercep*50*dt;
 poserror := posref - carpos;
 if carvel < 0.002 then  // stop car, release brake if close to stopped
  begin
   carvel := 0.0;
   poserror := 0.0;
  end;
 velref := posgain*poserror;
 velerror := velref - velpercep ;
// acceleration control smoothing to avoid computational oscillations
 maxaccelerror := maxaccelerror + 0.05*(AccelLimRef - caraccel - maxaccelerror);
 if maxaccelerror < 0.0 then maxaccelerror := 0.0;
 accelref := velgain*velerror;
 accelerror := accelref - caraccel + maxaccelerror*AccelLimGain;
// brake push smoothing to avoid computational oscillations
 brakepush := brakepush +  0.01*(-accelgain*accelerror- brakepush);
 if brakepush < 0.0 then brakepush := 0;
 brakeforce := 20*brakepush*KFrict;
 engineforce := -0.05*(carvel - 1000.0/3600.0*idlespeed);
 caraccel := -brakeforce/carmass + engineforce;
end;

procedure iterate;
begin
 if firsttime then
  begin
   firsttime := false;
   initprogram;
  end;
 movecar;
 showcar;
end;

procedure TFCarStop7.idleloop(Sender: TObject; var Done: boolean);
var t1, t2: int64;
    endtime: int64;
begin
 done := false;
 if realtime then endtime := 340 else endtime := freq;
 QueryPerformanceCounter(t1);
 iterate;
 repeat
  QueryPerformanceCounter(t2);
  application.ProcessMessages;
 until t2 - t1 >= freq div endtime;
end;


procedure TFCarStop7.StartCar(Sender: TObject);
begin
  application.onIdle := idleloop;
  queryperformancefrequency(freq);
  firsttime := true;
  realtime := true;
end;

procedure TFCarStop7.pgainChange(Sender: TObject);
begin
 with pgain do
 begin
  PosGain := (position)/max;
  FCarStop7.Canvas.textout(pgain.left,pgain.top+20,
       'Pos Gain = '+floattostrf(posgain,fffixed,5,2));
 end;
end;

procedure TFCarStop7.VgainChange(Sender: TObject);
begin
 with vgain do
 begin
  VelGain := 10.0*position/max;
  FCarStop7.Canvas.textout(vgain.left,vgain.top+20,
     'VelGain = '+floattostrf(velgain,fffixed,5,2));
 end;
end;

procedure TFCarStop7.AGainChange(Sender: TObject);
begin
 with again do
 begin
  AccelGain := 10.0*again.position/again.max;
  FCarStop7.Canvas.textout(again.left,again.top+20,
     'Accel Gain = '+floattostrf(accelgain,fffixed,5,2));
 end;

end;

procedure TFCarStop7.CmassChange(Sender: TObject);
begin
 with cmass do
 begin
  carmass := position;
  FCarStop7.Canvas.textout(cmass.left,cmass.top+20,
     'Car Mass = '+floattostrf(carmass,fffixed,5,2));
 end;
end;

procedure TFCarStop7.SetPosChange(Sender: TObject);
var y: integer;
begin
 PosRef := SetPos.position;
 with FCarStop7.Canvas do
 begin
  textout(SetPos.left,SetPos.top+20,
    'Ref Pos = '+floattostrf(PosRef,fffixed,5,2));

  y := Clientheight div 2 - 50;
  brush.color := clWhite;
  pos := rect(0,y,clientwidth-1,y+20);
  fillrect(pos);
 end;
end;

procedure TFCarStop7.SetAcLimGainChange(Sender: TObject);
begin
 with SetAcLimGain do
 begin
  AccelLimGain := 100*position/max;
  FCarStop7.Canvas.textout(SetAcLimGain.left,SetAcLimGain.top+20,
     'Accel Limit Gain = '+floattostrf(AccelLimGain,fffixed,5,2));
 end;

end;

procedure TFCarStop7.SetAccelRefChange(Sender: TObject);
begin
 with SetAccelRef do
 begin
  AccelLimRef := -position/10.0;
  FCarStop7.Canvas.textout(SetAccelRef.left,SetAccelRef.top+20,
     'Accel Limit Ref = '+floattostrf(AccelLimRef,fffixed,5,2));
 end;

end;

procedure TFCarStop7.Button1Click(Sender: TObject);
begin
 realtime := not realtime;
 if realtime then button1.caption := 'Change to Fast Time'
 else button1.caption := 'Change to Real Time';
end;


procedure TFCarStop7.InitSpeedChange(Sender: TObject);
begin
 with InitSpeed do
 begin
  InitVel := position;
  FCarStop7.Canvas.textout(InitSpeed.left,InitSpeed.top+20,
     'Initial Vel = '+floattostrf(InitVel,fffixed,5,2));
 end;


end;

end.
